#pragma once

#include "UIListCommonDefine.hpp"
#include <list>

#define MSG_CLOSE_CHAT_SEARCH (WM_USER + 9940)

namespace DuiLib
{
struct ChatSearchItemInfo
{
    ChatSearchItemInfo()
    {
        folder = false;
        empty = true;
    }
	bool folder;
	bool empty;
	CDuiString id;
	CDuiString logo;
	CDuiString nick_name;
	CDuiString description;
};


class CChatSearchList : public CListUI
{
public:
	enum {SCROLL_TIMERID = 10};

	CChatSearchList(CPaintManagerUI& paint_manager, HWND hWnd);

	~CChatSearchList();

	bool Add(CControlUI* pControl);

	bool AddAt(CControlUI* pControl, int iIndex);

	bool Remove(CControlUI* pControl);

	bool RemoveAt(int iIndex);

	void RemoveAll();

	void DoEvent(TEventUI& event);

	Node* GetRoot();

	Node* AddNode(const ChatSearchItemInfo& item, int nCompareData=0, Node* parent = NULL, int nTopPadding = 0);

	bool RemoveNode(Node* node);

	void SetChildVisible(Node* node, bool visible);

	bool CanExpand(Node* node) const;
	
	HWND GetParentHwnd();
	/*bool SelectItem(int iIndex, bool bTakeFocus = false);

	bool SelectItems(int iIndex, bool bTakeFocus = false);
	bool SelectItemSingle(int iIndex, bool bTakeFocus = false);
	bool UnSelectItemSingle(int iIndex, bool bTakeFocus = false);*/
	list<Node*> GetSelectedItems();
	void SetSelectViewModal( CControlUI* pControl, bool bSelect);
	
public:
	CPaintManagerUI& paint_manager_;
private:
	Node*	root_node_;
	LONG	delay_deltaY_;
	DWORD	delay_number_;
	DWORD	delay_left_;
	CDuiRect	text_padding_;
	int level_text_start_pos_;
	CDuiString level_expand_image_;
	CDuiString level_collapse_image_;

    CDialogBuilder m_dlgBuilder;
	HWND m_hParent;
};

} // DuiLib
